#include "Person.h"
#include <algorithm>
#include <ios>
#include <iostream>
#include <fstream>
#include <iomanip>
std::ostream& operator << (std::ostream& out, const Person& data) {
	for (auto i = data.cont.begin(); i != data.cont.end(); ++i) {
		out << std::endl << std::setw(14) << i->full_name << std::setw(6) << "|" <<
			std::setw(12) << i->enrollment_date << std::setw(6) << "|" <<
			std::setw(8) << i->personnel_number << std::setw(8) << "|" <<
			std::setw(8) << i->department_number << std::setw(7) << "|" <<
			std::setw(12) << i->salary << std::setw(10) << "|" <<
			std::setw(14) << i->bonus_percentage << std::setw(10) << "|" <<
			std::setw(9) << i->income_tax << std::setw(8) << "|" <<
			std::setw(12) << i->number_of_days_worked << std::setw(10) << "|" << std::endl;

	}
	return out;
}

std::istream& operator >> (std::istream& in, Person& data) {
	data = Person();
	while (true) {
		Person::Data d;
		in >> d.full_name;
		in >> d.enrollment_date;
		if (d.full_name == "\\0" && d.enrollment_date == "\\0" || d == Person::Data()) {
			data.cont.insert(Person::Data());
			break;
		}
		in >> d.personnel_number;
		in >> d.department_number;
		in >> d.salary;
		in >> d.bonus_percentage;
		in >> d.income_tax;
		in >> d.number_of_days_worked;
		data.cont.insert(d);
	}
	return in;
}

bool Person::operator == (const Person& data) {
	if (cont.size() != data.cont.size())
		return false;
	auto i = cont.begin();
	auto j = data.cont.begin();
	while (i != cont.end() && j != data.cont.end()) {
		if (*i != *j)
			return false;
		++i;
		++j;
	}
	return true;
}

void Person::add(std::ofstream& file) {
	for (auto i = cont.begin(); i != cont.end(); ++i) {
		file.write((char*)&(*i), sizeof(Data));
	}
}

void Person::read(std::ifstream& file) {
	while (!file.eof()) {
		Person::Data d;
		file.read((char*)&d, sizeof(Data));
		cont.insert(d);
	}
}

void Person::create_file(std::ofstream& file) {
	Person data;
	std::cin >> data;
	data.add(file);
}

void Person::delete_data(std::ofstream& file_write, std::ifstream& file_read) {
	Person data;
	data.read(file_read);
	bool b = true;
	for (auto i = data.cont.begin(); i != data.cont.end(); ++i) {
		if (b && !i->in(cont))
			data.add(file_write);
		else
			b = false;
		if (!b)
			data.add(file_write);
	}
}

void Person::replacement(std::ofstream& file_write, std::ifstream& file_read, Person& data) {
	this->delete_data(file_write, file_read);
	data.add(file_write);
}

void Person::convert_to_txt(std::ofstream& file_write, std::ifstream& file_read) {;

	file_write << std::setw(14) << "Full name" << std::setw(6) << "|" <<
		std::setw(12) << "Enrollment date" << std::setw(6) << "|" <<
		std::setw(10) << "Personnel number" << std::setw(6) << "|" <<
		std::setw(9) << "Department number" << std::setw(6) << "|" <<
		std::setw(16) << "Salary" << std::setw(6) << "|" <<
		std::setw(18) << "Bonus percentage" << std::setw(6) << "|" <<
		std::setw(11) << "Income tax" << std::setw(6) << "|" <<
		std::setw(16) << "Number of days worked" << std::setw(6) << "|";

	while (!file_read.eof()) {
		Person data;
		data.read(file_read);
		file_write << data;
	}


}
void Person::find_full_name(const std::string& p, std::ofstream& file)
{
    //!!! По заднию нужно использовать алгоритмы с предикатами
    
	for (auto i = cont.begin(); i != cont.end(); ++i) {
		if (i->full_name == p) {
			file.write((char*)&(*i), sizeof(Data));
		}
	}

}

void Person::find_department_number(int p, std::ofstream& file)
{
    //!!! По заднию нужно использовать алгоритмы с предикатами
    
	for (auto i = cont.begin(); i != cont.end(); ++i) {
		if (i->department_number == p) {
			file.write((char*)&(*i), sizeof(Data));
		}
	}

}

void Person::find_enrollment_date(const std::string& p, std::ofstream& file)
{
    //!!! По заднию нужно использовать алгоритмы с предикатами
    
	for (auto i = cont.begin(); i != cont.end(); ++i) {
		if (i->enrollment_date == p) {
			file.write((char*)&(*i), sizeof(Data));
		}
	}

}